  #include <AT89X51.H>
	//Include file for 8051
#define keyport P2	//keypad connected to P2
#define col1 P2_0	//column 1
#define col2 P2_1	//column 2
#define col3 P2_2	//column 3
#define col4 P2_3	//column 4

 
unsigned char get_key();
void serial_send(unsigned char dat);
void serial_init();

 
 void main()
 {
  unsigned char keycode; 
	 serial_init();  //for output
	 keyport =0xff;     	//all keypad pins high 
	 while(1)
	 {

		keycode=get_key();
		 if(keycode)	
			 serial_send(keycode);
	 }
	 
 }
 
 

 
/*
+-----------------------------------------------+
| Prototype: unsigned char get_key(void);       |
| Return Type: unsigned char                    |
| Arguments: None                               |
| Description: To read key from the keypad      |
+-----------------------------------------------+
*/

//return 0 for no key pressed or a code 1 to 16
unsigned char get_key(){
	unsigned char i,k,key=0;
	k=1;
	for(i=0;i<4;i++){		//loop for 4 rows
		keyport &=~(0x80>>i);	//to make rows low 1 by 1
			if(!col1){	//check if key1 is pressed
				key = k+0;	//set key number
				while(!col1);	//wait for release
				return key;	//return key number
			}
			if(!col2){	//check if key2 is pressed
				key = k+1;	//set key number
				while(!col2);	//wait for release
				return key;	//return key number
			}
			if(!col3){	//check if key3 is pressed
				key = k+2;	//set key number
				while(!col3);	//wait for release
				return key;	//return key number
			}
			if(!col4){	//check if key4 is pressed
				key = k+3;	//set key number
				while(!col4);	//wait for release
				return key;	//return key number
			}
		k+=4;			//next row key number
		keyport |= 0x80>>i;	//make the row high again
	}
	return 0;			//return 0 if no key pressed
}

 //serial port used for test messages
 void serial_init()
{
	TMOD = 0x20;
	SCON = 0x50;
	TH1  = 0xFD; //Set baudrate to 9600 at 11.0592MHz
	TL1  = 0xFD;
	TR1  = 1;
	TI=1;
}
void serial_send(unsigned char dat)
	{
	while(!TI);
	TI = 0;
	SBUF = dat;
}

